#!/usr/bin/perl -T -w
# Used for moving code format back into human readable life format.

&search;

sub search {
  local ($col, $row, $stack, $zone);
  local ($x, $y, $z, $w);
  local ($NOTUSED);
  local (@array);

  $HALFMAX = 64; # really 32 but being safe
  $MINCOL = $MINROW = $MINSTACK = $MINZONE = $HALFMAX;
  $MAXCOL = $MAXROW = $MAXSTACK = $MAXZONE = $HALFMAX;
  $NOTUSED = -127;
  $col = $row = $stack = $zone = $NOTUSED;
  $number = 0;
  while (<>) {
    if (!($_ =~ /^#/)) {
      @chars = split(//);
      $number = 0;
      $col = $NOTUSED;
      $negative = 1;
      foreach $c (@chars) {
        if ($c =~ /[-]/) {
          $negative = -1;
        } elsif ($c =~ /[0123456789]/) {
          $number = $number * 10 + ($c - '0');
        } elsif ($c =~ /[,]/) { # Last number does not have a ","
          if ($row > $NOTUSED && $col > $NOTUSED && $stack > $NOTUSED) {
            $zone = $number * $negative;
            $col = $col + $HALFMAX;
            $row = $row + $HALFMAX;
            $stack = $stack + $HALFMAX;
            $zone = $zone + $HALFMAX;
            $array{$col, $row, $stack, $zone} = 1;
            if ($col > $MAXCOL) {
              $MAXCOL = $col;
            } elsif ($col < $MINCOL) {
              $MINCOL = $col;
            }
            if ($row > $MAXROW) {
              $MAXROW = $row;
            } elsif ($row < $MINROW) {
              $MINROW = $row;
            }
            if ($stack > $MAXSTACK) {
              $MAXSTACK = $stack;
            } elsif ($stack < $MINSTACK) {
              $MINSTACK = $stack;
            }
            if ($zone > $MAXZONE) {
              $MAXZONE = $zone;
            } elsif ($zone < $MINZONE) {
              $MINZONE = $zone;
            }
            $row = $NOTUSED;
            $col = $NOTUSED;
            $stack = $NOTUSED;
          } elsif ($row > $NOTUSED && $col > $NOTUSED) {
            $stack = $number * $negative;
          } elsif ($col > $NOTUSED) {
            $row = $number * $negative;
          } else {
            $col = $number * $negative;
          }
          $number = 0;
          $negative = 1;
        } elsif ($c =~ /[{}\/]/) { # Last number does not have a ","
          $col = $NOTUSED;
          $number = 0;
          $negative = 1;
        }
      }
    }
  }
  $x=$MAXCOL - $MINCOL + 1;
  $y=$MAXROW - $MINROW + 1;
  $z=$MAXSTACK - $MINSTACK + 1;
  $w=$MAXZONE - $MINZONE + 1;
  print "#x=$x, y=$y, z=$z, w=$w\n";
  for ($l = $MINZONE; $l <= $MAXZONE; $l++) {
    for ($k = $MINSTACK; $k <= $MAXSTACK; $k++) {
      for ($j = $MINROW; $j <= $MAXROW; $j++) {
        for ($i = $MINCOL; $i <= $MAXCOL; $i++) {
          if ($array{$i, $j, $k, $l}) {
            print "*";
          } else {
            print ".";
          }
        }
        print "\n";
      }
      print "\n";
    }
    print "\n";
  }
}
