package com.sillycycle.bagleyd.util;

import java.awt.Point;

public class Point4D extends Point {
	private static final long serialVersionUID = 42L;
	public int z, w;

	public double getZ() {
		return z;
	}

	public double getW() {
		return w;
	}

	public Point4D(Point3D p, int w) {
		this.x = p.x;
		this.y = p.y;
		this.z = p.z;
		this.w = w;
	}

	public Point4D() {
		super.x = 0;
		super.y = 0;
		this.z = 0;
		this.w = 0;
	}

	public Point4D(int x, int y, int z, int w) {
		super.x = x;
		super.y = y;
		this.z = z;
		this.w = w;
	}

	public void move(int x, int y, int z, int w) {
		this.z = z;
		this.w = w;
		super.move(x, y);
	}

	public void translate(int x, int y, int z, int w) {
		this.z += z;
		this.w += w;
		super.translate(x, y);
	}

	/**
	 * Returns the hashcode for this <code>Point4D</code>.
	 * @return a hash code for this <code>Point4D</code>.
	 */
	@Override
	public int hashCode() {
		long bits = java.lang.Double.doubleToLongBits(getX());
		bits ^= java.lang.Double.doubleToLongBits(getY()) * 31;
		bits ^= java.lang.Double.doubleToLongBits(getZ()) * 29;
		bits ^= java.lang.Double.doubleToLongBits(getW()) * 23;
		return (((int) bits) ^ ((int) (bits >> 32)));
	}

	/**
	 * Determines whether or not two points are equal. Two instances of
	 * <code>Point4D</code> are equal if the values of their
	 * <code>x</code>, <code>y</code>, <code>z</code> and <code>w</code>
	 * member fields, representing their position in the coordinate space,
	 * are the same.
	 * @param obj an object to be compared with this <code>Point4D</code>
	 * @return <code>true</code> if the object to be compared is
	 *         an instance of <code>Point4D</code> and has
	 *         the same values; <code>false</code> otherwise.
	 */
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof Point4D) {
			Point4D pt = (Point4D) obj;
			return (x == pt.x) && (y == pt.y) &&
				(z == pt.z) && (w == pt.w);
		}
		return super.equals(obj);
	}

}
